package uebung08.doc;

import java.util.ArrayList;
import java.util.List;

public class Book {

    private String title;
    private String author;

    List<TextComponent> content;

    public Book(String author, String title, List<TextComponent> content) {
        this.author = author;
        this.title = title;
        this.content = content;
    }

    public int countWords() {
        int wordcount = 0;
        for (TextComponent textComponent : content) {
            wordcount += textComponent.countWords();
        }
        return wordcount;
    }

    public String toText() {
        return "";
    }

    public String tableOfContents() {
        List<String> res = new ArrayList<>();

        for (TextComponent textComponent : content) {
            res.addAll(textComponent.accept(new TableOfContentsVisitor()));
        }

        return res.toString();
    }

    public int countWordsByVisitor() {
        int count = 0;

        for (TextComponent textComponent : content) {
            count += textComponent.accept(new CountWordsVisitor());
        }

        return count;
    }
}
